/**
 * Yum Food Orders
 * **Yum application, order food daily from the best chef in town**  This API is used by the angular.io client, and is not meant to be used otherwise.  Find source code of this API [here](http://gitlab/)  Copyright (C) 2017 JR Technologies.
 *
 * OpenAPI spec version: 1.1.0
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class ChefApi {
    protected basePath = 'http://localhost:8082/api';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    private convertDates(res: Response) {
      var data = res.json() || [];
      data.forEach((d) => {
        d.date = new Date(d.date);
      });
      return data;
    }

    private convertDate(res: Response) {
      var data = res.json() || {};
        data.date = new Date(data.date);
      return data;
    }

    private convertDailyMenuSave(body: models.DailyMenuSave): string {
      const convertedBody = {
        id : body.id,
        date : body.date.getFullYear() + '-' + (body.date.getMonth() + 1) + '-' + body.date.getDate(),
        version : body.version,
        foods : body.foods
      }

      return JSON.stringify(convertedBody);
    }


    /**
     * updates DailyMenu by ID
     * updates DailyMenu by ID
     * @param id
     * @param body
     */
    public dailyMenusIdPut(id: number, body: models.DailyMenuSave, extraHttpRequestParams?: any): Observable<models.DailyMenuSave> {
        return this.dailyMenusIdPutWithHttpInfo(id, body, extraHttpRequestParams)
            .map((response: Response) => {
                if ( response.status === 400 ) {
                    return undefined;
                } else {
                    return this.convertDate(response);
                }
            });
    }

    /**
     * Returns a list containing all daily menus of the current month
     * Returns a list containing all daily menus of the current month
     */
    public dailyMenusMonthlyGet(extraHttpRequestParams?: any): Observable<models.DailyMenusChef> {
        return this.dailyMenusMonthlyGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return this.convertDates(response);
                }
            });
    }

    /**
     * Returns a list containing all daily Menus of the given month
     * The monthly menu fetches the daily menus of a month. Each daily menu contains the list of foods offered for that day along with the price it costs and the quantity ordered by all users.
     * @param month
     * @param year
     */
    public dailyMenusMonthlyYearMonthGet(month: number, year: number, extraHttpRequestParams?: any): Observable<models.DailyMenusChef> {
        return this.dailyMenusMonthlyYearMonthGetWithHttpInfo(month, year, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return this.convertDates(response);
                }
            });
    }

    /**
     * Creates a new DailyMenu
     * Creates a new DailyMenu
     * @param body
     */
    public dailyMenusPost(body: models.DailyMenuSave, extraHttpRequestParams?: any): Observable<models.NewEntry> {
        return this.dailyMenusPostWithHttpInfo(body, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                }
                else if(response.status === 409){
                  return this.convertDate(response);
                }
                else {
                    return response.json();
                }
            });
    }

    /**
     * returns a non archived food by its name
     * returns a non archived food by its name
     * @param name
     */
    public foodsFindByNameNameGet(name: string, extraHttpRequestParams?: any): Observable<models.EditedFood> {
        return this.foodsFindByNameNameGetWithHttpInfo(name, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Returns foods list
     * Returns foods list
     * @param version
     * @param archived
     * @param type
     * @param sort
     * @param order
     * @param page
     * @param size
     */
    public foodsGet(version?: number, archived?: boolean, type?: string, sort?: string, order?: string, page?: number, size?: number, extraHttpRequestParams?: any): Observable<models.FoodsList> {
        return this.foodsGetWithHttpInfo(version, archived, type, sort, order, page, size, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Deletes or archives an existing food.
     * Checks for the food&#39;s orderings and makes deletes or archives it.
     * @param id
     * @param archive
     */
    public foodsIdDelete(id: number, archive?: boolean, extraHttpRequestParams?: any): Observable<models.FoodDelete> {
        return this.foodsIdDeleteWithHttpInfo(id, archive, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Returns the requested food to edit
     * Returns the requested food to edit
     * @param id
     * @param edit
     */
    public foodsIdGet(id: number, edit?: boolean, extraHttpRequestParams?: any): Observable<models.FoodEditable> {
        return this.foodsIdGetWithHttpInfo(id, edit, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Edits or clones an existing food
     * Checks for the version of the food to solve the concurrent editing problem, proceeds with the editing or proposes to clone or rejects it.
     * @param id
     * @param body
     * @param clone
     */
    public foodsIdPut(id: number, body: models.EditedFood, clone?: boolean, extraHttpRequestParams?: any): Observable<models.NewEntry> {
        return this.foodsIdPutWithHttpInfo(id, body, clone, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Creates a new food
     * Creates a new food for global menu
     * @param body
     */
    public foodsPost(body: models.FoodSave, extraHttpRequestParams?: any): Observable<{}> {
        return this.foodsPostWithHttpInfo(body, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Returns daily orders summary for given daily menu Id
     * Returns daily orders summary for given daily menu Id
     * @param dailyMenuId
     */
    public ordersDailyDailyMenuIdGet(dailyMenuId: number, extraHttpRequestParams?: any): Observable<models.OrderSummary> {
        return this.ordersDailyDailyMenuIdGetWithHttpInfo(dailyMenuId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Returns daily orders of the current month
     * The monthly menu fetches all daily orders of the current month.
     */
    public ordersMonthlyGet(extraHttpRequestParams?: any): Observable<models.OrdersChef> {
        return this.ordersMonthlyGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return this.convertDates(response);
                }
            });
    }

    /**
     * Returns daily orders for given month
     * Returns daily orders for given month
     * @param month
     * @param year
     */
    public ordersMonthlyYearMonthGet(month: number, year: number, extraHttpRequestParams?: any): Observable<models.OrdersChef> {
        return this.ordersMonthlyYearMonthGetWithHttpInfo(month, year, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return this.convertDates(response);
                }
            });
    }


    /**
     * updates DailyMenu by ID
     * updates DailyMenu by ID
     * @param id
     * @param body
     */
    public dailyMenusIdPutWithHttpInfo(id: number, body: models.DailyMenuSave, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/dailyMenus/${id}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling dailyMenusIdPut.');
        }
        // verify required parameter 'body' is not null or undefined
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling dailyMenusIdPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: body == null ? '' : this.convertDailyMenuSave(body), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Returns a list containing all daily menus of the current month
     * Returns a list containing all daily menus of the current month
     */
    public dailyMenusMonthlyGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/dailyMenus/monthly`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Returns a list containing all daily Menus of the given month
     * The monthly menu fetches the daily menus of a month. Each daily menu contains the list of foods offered for that day along with the price it costs and the quantity ordered by all users.
     * @param month
     * @param year
     */
    public dailyMenusMonthlyYearMonthGetWithHttpInfo(month: number, year: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/dailyMenus/monthly/${year}/${month}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'month' is not null or undefined
        if (month === null || month === undefined) {
            throw new Error('Required parameter month was null or undefined when calling dailyMenusMonthlyYearMonthGet.');
        }
        // verify required parameter 'year' is not null or undefined
        if (year === null || year === undefined) {
            throw new Error('Required parameter year was null or undefined when calling dailyMenusMonthlyYearMonthGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Creates a new DailyMenu
     * Creates a new DailyMenu
     * @param body
     */
    public dailyMenusPostWithHttpInfo(body: models.DailyMenuSave, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/dailyMenus`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'body' is not null or undefined
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling dailyMenusPost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: body == null ? '' : this.convertDailyMenuSave(body), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * returns a non archived food by its name
     * returns a non archived food by its name
     * @param name
     */
    public foodsFindByNameNameGetWithHttpInfo(name: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/foods/findByName/${name}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'name' is not null or undefined
        if (name === null || name === undefined) {
            throw new Error('Required parameter name was null or undefined when calling foodsFindByNameNameGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Returns foods list
     * Returns foods list
     * @param version
     * @param archived
     * @param type
     * @param sort
     * @param order
     * @param page
     * @param size
     */
    public foodsGetWithHttpInfo(version?: number, archived?: boolean, type?: string, sort?: string, order?: string, page?: number, size?: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/foods`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        if (version !== undefined) {
            queryParameters.set('version', <any>version);
        }

        if (archived !== undefined) {
            queryParameters.set('archived', <any>archived);
        }

        if (type !== undefined) {
            queryParameters.set('type', <any>type);
        }

        if (sort !== undefined) {
            queryParameters.set('sort', <any>sort);
        }

        if (order !== undefined) {
            queryParameters.set('order', <any>order);
        }

        if (page !== undefined) {
            queryParameters.set('page', <any>page);
        }

        if (size !== undefined) {
            queryParameters.set('size', <any>size);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Deletes or archives an existing food.
     * Checks for the food&#39;s orderings and makes deletes or archives it.
     * @param id
     * @param archive
     */
    public foodsIdDeleteWithHttpInfo(id: number, archive?: boolean, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/foods/${id}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling foodsIdDelete.');
        }
        if (archive !== undefined) {
            queryParameters.set('archive', <any>archive);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Returns the requested food to edit
     * Returns the requested food to edit
     * @param id
     * @param edit
     */
    public foodsIdGetWithHttpInfo(id: number, edit?: boolean, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/foods/${id}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling foodsIdGet.');
        }
        if (edit !== undefined) {
            queryParameters.set('edit', <any>edit);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Edits or clones an existing food
     * Checks for the version of the food to solve the concurrent editing problem, proceeds with the editing or proposes to clone or rejects it.
     * @param id
     * @param body
     * @param clone
     */
    public foodsIdPutWithHttpInfo(id: number, body: models.EditedFood, clone?: boolean, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/foods/${id}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling foodsIdPut.');
        }
        // verify required parameter 'body' is not null or undefined
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling foodsIdPut.');
        }
        if (clone !== undefined) {
            queryParameters.set('clone', <any>clone);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: body == null ? '' : JSON.stringify(body), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Creates a new food
     * Creates a new food for global menu
     * @param body
     */
    public foodsPostWithHttpInfo(body: models.FoodSave, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/foods`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'body' is not null or undefined
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling foodsPost.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: body == null ? '' : JSON.stringify(body), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Returns daily orders summary for given daily menu Id
     * Returns daily orders summary for given daily menu Id
     * @param dailyMenuId
     */
    public ordersDailyDailyMenuIdGetWithHttpInfo(dailyMenuId: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/orders/daily/${dailyMenuId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'dailyMenuId' is not null or undefined
        if (dailyMenuId === null || dailyMenuId === undefined) {
            throw new Error('Required parameter dailyMenuId was null or undefined when calling ordersDailyDailyMenuIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Returns daily orders of the current month
     * The monthly menu fetches all daily orders of the current month.
     */
    public ordersMonthlyGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/orders/monthly`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Returns daily orders for given month
     * Returns daily orders for given month
     * @param month
     * @param year
     */
    public ordersMonthlyYearMonthGetWithHttpInfo(month: number, year: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/orders/monthly/${year}/${month}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'month' is not null or undefined
        if (month === null || month === undefined) {
            throw new Error('Required parameter month was null or undefined when calling ordersMonthlyYearMonthGet.');
        }
        // verify required parameter 'year' is not null or undefined
        if (year === null || year === undefined) {
            throw new Error('Required parameter year was null or undefined when calling ordersMonthlyYearMonthGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
